#!/usr/bin/python3

import tango
import sys


def check_corr_strength(mag,tol):
    """
    read correction strengh ed report if it is out of tolerance
    retunr number of modified magnets
    """

    print(mag.get_size(), ' magnets to be checked')

    ans = mag.read_attribute('CorrectionStrength')
    count: int = 0
    if not ans.has_failed():
        for repl in ans:
            if repl.has_failed():
                print('read CorrectionStrength failed for ', repl.dev_name())
            else:
                dt = repl.get_data()
                val = dt.value
                w_val = dt.w_value
                if abs(val) > tol or abs(w_val) > tol:
                    print(repl.dev_name(), " not at design strength: correction strength: ",val, w_val)
                    count += 1
    else:
        print("cal to group failed")
    return count




def main():
    tol= 1.45e-14
    mag = tango.Group("MAG")
    mag.add("sr/magnet/qf_*")
    mag.add("sr/magnet/qd_*")
    mag.add("sr/magnet/sf_*")
    mag.add("sr/magnet/sd_*")
    mag.add("sr/magnet/sh_*")
    mag.add("sr/magnet/c*")
    cnt = check_corr_strength(mag,tol)
    print("number of modified magnest: ",cnt)


if __name__ == '__main__':
    if __name__ == '__main__':
        sys.exit(main())
