#!/usr/bin/python3

import tango
import sys


def to_design_strength(mag):
    """
    initialize all the elettra2 magnets to the Design strength
    :return: void
    """

    print(mag.get_size(), ' Magnets to set to design strength')

    ans = mag.write_attribute('CorrectionStrength', 0.0)
    if ans.has_failed():
        print("failed...")
        for repl in ans:
            if repl.has_failed():
                print('CorrectionStrength=0.0  failed for ', repl.dev_name())
    else:
        print('DesigneStrength set to # ', mag.get_size(), ' magnets')


def main():
    mag = tango.Group("MAG")
    mag.add("sr/magnet/qf_*")
    mag.add("sr/magnet/qd_*")
    mag.add("sr/magnet/sf_*")
    mag.add("sr/magnet/sd_*")
    mag.add("sr/magnet/sh_*")
    mag.add("sr/magnet/c*")
    to_design_strength(mag)


if __name__ == '__main__':
    if __name__ == '__main__':
        sys.exit(main())
