#!/usr/bin/python3
# send command ON to all the elettra2 power supplies and turns ON|OFF the ripple
import tango
import sys


def turn_ripple(ripple_flag, psg):
    """
    :param ripple_flag: true turns on the current ripple of the power supplies
    :param psg: tango group of power supplies
    :return: void
    """
    ans = psg.write_attribute('AddRipple', ripple_flag)
    if ans.has_failed():
        print("failed...")
        for repl in ans:
            if repl.has_failed():
                print('AddRipple failed for ', repl.dev_name())
    else:
        print('AddRipple set to', psg.get_size(), ' magnets', ' to:', ripple_flag)
    pass


def main():
    add_ripple = False
    print(len(sys.argv))
    if len(sys.argv) < 2:
        print("usage : ", sys.argv[0], " [AddRipple] ON|OFF")
        return -1
    args = sys.argv[1]
    if args == "ON":
        add_ripple = True
    if args == "OFF":
        add_ripple = False

    psg = tango.Group("PS")
    psg.add("sr/power_supply/ps*")
    ans = psg.command_inout("ON")
    if ans.has_failed():
        print("failed...")
        for repl in ans:
            if repl.has_failed():
                print('ON failed for ', repl.dev_name())
    else:
        print('command  ON sent to ', psg.get_size(), ' power supplies')
    turn_ripple(add_ripple, psg)


if __name__ == '__main__':
    sys.exit(main())
